#include <algorithm>
#include <cassert>
#include <sstream>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#define rep(i,a,b) for(int i=(a);i<(b);++i)
#define trav(it,v) for(typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)
#define MP(x,y) make_pair(x,y)
#define FI(x) (x).first
#define SE(x) (x).second
using namespace std;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpii;

vi bb(string s) {istringstream is(s);int x;vi rt;while(is >> x) rt.push_back(x); return rt; }
template<typename t>ostream&operator<<(ostream&os,const vector<t>&v){rep(i,0,v.size())os<<v[i]<<' ';return os;}
string compact(vi p){ostringstream os;trav(it,p)os<<(*it);return os.str();}

struct match {
	match(int=0);
	vi p;
	int n;	
	int&operator[](int k){return p[k];}
	bool operator<(const match& P) const {return p < P.p;}
};

ostream&operator<<(ostream&os,const match&M){os<<M.p;return os;}

match::match(int _n) 
:n(_n) {
	p.resize(2*n);
}

vector<vector<match> > all;
vector<map<match, int> >all_rev;

void generate(int n) { //generate all matchings on <=2n elements
	all.resize(n+1); all_rev.resize(n+1);
	all[0].push_back(match()); 
	all_rev[0][match()] = 0;
	for(int N = 0; N <= n; ++N) {
		int ct = 0;
		for(int i = 1; i < 2*N; i += 2) {
			//generate all M with M[0] = i;
			match M(N);
			M[0] = i; M[i] = 0;
			//i-1 places inside, 2n-2-(i-1) =2n-1+i places outside	
			int n_in = (i-1)/2, n_out = (2*N-2-(i-1))/2;
			rep(k,0,all[n_in].size()) 
			rep(l,0,all[n_out].size()) {
				for(int t = 1; t < i; ++t) 
					M[t] = 1+all[n_in][k][t-1];
				for(int t = i+1; t < 2*N; ++t)
					M[t] = i+1+all[n_out][l][t-(i+1)];
				all[N].push_back(M);
				all_rev[N][M] = ct++;
			}
		}
	}
}

match canon(match M) {
	int n = M.n;
	match rt=M;
	rep(t,0,2*n) {
		int c = M[0];
		rep(i,0,2*n-1) {
			M[i] = (M[i+1]+2*n-1)%(2*n);	
		}
		M[2*n-1] = (c+2*n-1)%(2*n);
		if(M < rt) rt = M;
	}
	reverse(M.p.begin(), M.p.end());
	rep(t,0,2*n) M[t] = 2*n-1-t;
	//and the reverse ones. (Is this neccesary only for n >= 9?)
	rep(t,0,2*n) {
		int c = M[0];
		rep(i,0,2*n-1) {
			M[i] = (M[i+1]+2*n-1)%(2*n);	
		}
		M[2*n-1] = (c+2*n-1)%(2*n);
		if(M < rt) rt = M;
	}
	return rt;
}

match hi(match p, int i) {
	int ip = (i+1)%(2*p.n);
	if(p[i] == ip) return p;
	int k = p[i], l = p[ip];
	p[i] = ip; p[ip] = i;
	p[k] = l; p[l] = k;
	return p;
}

void matrix(int n) {
	generate(n);
	int S = all[n].size();
	vvi R(S, vi(S,0));
	rep(i,0,S) {
		match M = all[n][i];
		rep(k,0,2*n) {
			match Mp = hi(M, k);
			R[all_rev[n][Mp]][i]++;
		}
	}
	cout << "R:=Matrix(["<<endl;
	rep(i,0,S) {
		cout << "[";
		rep(j,0,S) {
			cout << R[i][j];
			if(j != S-1) cout << ",";
		}
		cout << "]"; if(i != S-1) cout << ",";
		cout << endl;
	}
	cout << "]);"<< endl;
}

void matrix_red(int n) { //red(uced)
	generate(n);
	vector<match> all_red;
	map<match, int> all_red_rev;
	{
		set<match> tmp;
		trav(it, all[n])
			tmp.insert(canon(*it));
		int ct = 0;
		trav(it, tmp) {
			all_red_rev[*it] = ct++;
			all_red.push_back(*it);
		}
	}
	int S = all_red.size();
	vvi R(S, vi(S,0));
	rep(i,0,S) {
		match M = all_red[i];
		rep(k,0,2*n) {
			match Mp = canon(hi(M, k));
			R[all_red_rev[Mp]][i]++;
		}
	}
	cout << "R"<<n<<":=Matrix(["<<endl;
	rep(i,0,S) {
		cout << "[";
		rep(j,0,S) {
			cout << R[i][j];
			if(j != S-1) cout << ",";
		}
		cout << "]"; if(i != S-1) cout << ",";
		cout << endl;
	}
	cout << "]);"<< endl;

	cout << "Nodes" << endl;
	rep(t,0,all_red.size()) {
		cout << t << " : " << all_red[t] << endl;
	}
}

int main(int argc, char**argv) {
	if(argc > 1)
		matrix_red(atoi(argv[1]));


	return 0;
}
